%parametros del motor de induccion
R=2; %ohms
L=0.5; %henries
km=.015;
kb=.015;
beta=.2;
J=0.02;

%modelo de la planta en variables de estado
a11=-R/L;
a12=-kb/L;
a21=km/J;
a22=-beta/J;
b11=1/L;
b21=0;
c11=1;
c12=0;
A=[a11 a12; a21 a22];
B=[b11; b21];
C=[1 0];
D=0;
sys=SS(A,B,C,D)
ps=pole(sys);
pp1=ps(1)
pp2=ps(2)

%modelo en funcion de transferencia
[numtf, dentf]=ss2tf(A,B,C,D);
systf=tf(numtf,dentf);

%especificaciones de diseo del observador
Ms=.1;
te=.978/4;

%calculo de los polos deseados
csi=(1+(pi/(log(Ms)))^2)^-.5;
wn=-log(0.02)/(csi*te);
po1=-csi*wn+i*wn*(1-csi^2)^.5;
po2=-csi*wn-i*wn*(1-csi^2)^.5;

%vector de coeficientes del polinomio caracteristico del sistema
apla=[-pp1-pp2; pp1*pp2]

%vector de coeficientes del polinomio caracteristico desado 
aest=[-po1-po2; po1*po2]

N=[C' A'*C']
W=[1 apla(1); 0 1]

K=inv((N*W)')*(aest-apla)




